#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "timer.h"

const	int	N = 1000;

// ------------------
   double mad1(int n)
// ------------------
{
  int i, j, k;
  double s = 0.0, t = 0.0, u = 0.0;

/*
  for (i = -n; i <= n; i++)
    for (j = -n; j <= n; j++)
      for (k = -n; k <= n; k++) {
        if (i == 0 && j == 0 && k == 0)
          continue;
        s += ((i+j+k) % 2 == 0) ? -1.0/sqrt((double)(i*i+j*j+k*k)) : 1.0/sqrt((double)(i*i+j*j+k*k));
      }

  return s;
*/

  for (i = 1; i <= n; i++)
    for (j = 1; j <= n; j++)
      for (k = 1; k <= n; k++)
        s += ((i+j+k) % 2 == 0) ? -1.0/sqrt((double)(i*i+j*j+k*k)) : 1.0/sqrt((double)(i*i+j*j+k*k));
  s *= 8.0;

  for (i = 1; i <= n; i++)
    for (j = 1; j <= n; j++)
      t += ((i+j) % 2 == 0) ? -1.0/sqrt((double)(i*i+j*j)) : 1.0/sqrt((double)(i*i+j*j));
  t *= 12.0;
  
  for (i = 1; i <= n; i++)
    u += (i % 2 == 0) ? -1.0/(double)i : 1.0/(double)i;
  u *= 6.0;
  
  return s+t+u;
}

// -----------------------------
   void mad2(double *mad, int n)
// -----------------------------
{
  int i, j;
  double t = 0.0, u = 0.0, v, w = 0.0, x, y;

  for (i = 1; i < n; i++)
    for (j = 1; j < n; j++)
      t += ((i+j+n) % 2 == 0) ? -1.0/sqrt((double)(i*i+j*j+n*n)) : 1.0/sqrt((double)(i*i+j*j+n*n));
  t *= 24.0;

  for (i = 1; i < n; i++)
    u += ((i+n+n) % 2 == 0) ? -1.0/sqrt((double)(i*i+n*n+n*n)) : 1.0/sqrt((double)(i*i+n*n+n*n));
  u *= 24.0;

  v = ((n+n+n) % 2 == 0) ? -8.0/sqrt((double)(n*n+n*n+n*n)) : 8.0/sqrt((double)(n*n+n*n+n*n));

  for (i = 1; i < n; i++)
    w += ((i+n) % 2 == 0) ? -1.0/sqrt((double)(i*i+n*n)) : 1.0/sqrt((double)(i*i+n*n));
  w *= 24.0;

  x = ((n+n) % 2 == 0) ? -12.0/sqrt((double)(n*n+n*n)) : 12.0/sqrt((double)(n*n+n*n));

  y = (n % 2 == 0) ? -6.0/(double)n : 6.0/(double)n;

  *mad += (t + u + v + w + x + y);
}

// -----------------------------
   void mad3(double *mad, int n)
// -----------------------------
{
  int i, j;
  double t, u, v, w, x, y;

  if (n > 1) {
    int m = n - 1;

    t = u = w = 0.0;
    for (i = 1; i < m; i++)
      for (j = 1; j < m; j++)
        t += ((i+j+m) % 2 == 0) ? -1.0/sqrt((double)(i*i+j*j+m*m)) : 1.0/sqrt((double)(i*i+j*j+m*m));
    t *= 12.0;

    for (i = 1; i < m; i++)
      u += ((i+m+m) % 2 == 0) ? -1.0/sqrt((double)(i*i+m*m+m*m)) : 1.0/sqrt((double)(i*i+m*m+m*m));
    u *= 6.0;

    v = ((m+m+m) % 2 == 0) ? -1.0/sqrt((double)(m*m+m*m+m*m)) : 1.0/sqrt((double)(m*m+m*m+m*m));

    for (i = 1; i < m; i++)
      w += ((i+m) % 2 == 0) ? -1.0/sqrt((double)(i*i+m*m)) : 1.0/sqrt((double)(i*i+m*m));
    w *= 12.0;

    x = ((m+m) % 2 == 0) ? -3.0/sqrt((double)(m*m+m*m)) : 3.0/sqrt((double)(m*m+m*m));

    y = (m % 2 == 0) ? -3.0/(double)m : 3.0/(double)m;

    *mad -= (t + u + v + w + x + y);

    t = u = w = 0.0;
    for (i = 1; i < m; i++)
      for (j = 1; j < m; j++)
        t += ((i+j+m) % 2 == 0) ? -1.0/sqrt((double)(i*i+j*j+m*m)) : 1.0/sqrt((double)(i*i+j*j+m*m));
    t *= 24.0;

    for (i = 1; i < m; i++)
      u += ((i+m+m) % 2 == 0) ? -1.0/sqrt((double)(i*i+m*m+m*m)) : 1.0/sqrt((double)(i*i+m*m+m*m));
    u *= 24.0;

    v = ((m+m+m) % 2 == 0) ? -8.0/sqrt((double)(m*m+m*m+m*m)) : 8.0/sqrt((double)(m*m+m*m+m*m));

    for (i = 1; i < m; i++)
      w += ((i+m) % 2 == 0) ? -1.0/sqrt((double)(i*i+m*m)) : 1.0/sqrt((double)(i*i+m*m));
    w *= 24.0;

    x = ((m+m) % 2 == 0) ? -12.0/sqrt((double)(m*m+m*m)) : 12.0/sqrt((double)(m*m+m*m));

    y = (m % 2 == 0) ? -6.0/(double)m : 6.0/(double)m;

    *mad += (t + u + v + w + x + y);
  }

  t = u = w = 0.0;
  for (i = 1; i < n; i++)
    for (j = 1; j < n; j++)
      t += ((i+j+n) % 2 == 0) ? -1.0/sqrt((double)(i*i+j*j+n*n)) : 1.0/sqrt((double)(i*i+j*j+n*n));
  t *= 12.0;

  for (i = 1; i < n; i++)
    u += ((i+n+n) % 2 == 0) ? -1.0/sqrt((double)(i*i+n*n+n*n)) : 1.0/sqrt((double)(i*i+n*n+n*n));
  u *= 6.0;

  v = ((n+n+n) % 2 == 0) ? -1.0/sqrt((double)(n*n+n*n+n*n)) : 1.0/sqrt((double)(n*n+n*n+n*n));

  for (i = 1; i < n; i++)
    w += ((i+n) % 2 == 0) ? -1.0/sqrt((double)(i*i+n*n)) : 1.0/sqrt((double)(i*i+n*n));
  w *= 12.0;

  x = ((n+n) % 2 == 0) ? -3.0/sqrt((double)(n*n+n*n)) : 3.0/sqrt((double)(n*n+n*n));

  y = (n % 2 == 0) ? -3.0/(double)n : 3.0/(double)n;

  *mad += (t + u + v + w + x + y);
}



// ==============
   int main(void)
// ==============
{
  int n;
  double m;
  Timer timer;

/*
  timer.start();
  for (n = 1; n <= N; n++) {
    m = mad1(n);
    if (n >= N-10)
      printf("n = %4d:  m = %17.14f\n", n, m);
  }
  timer.stop(); timer.print();
*/

  timer.start();
  m = 0.0;
  for (n = 1; n <= N; n++) {
    mad3(&m, n);
    if (n >= N-10)
      printf("n = %4d:  m = %17.14f\n", n, m);
  }
  timer.stop(); timer.print();
}
